#include <wiringPi.h>

#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>


#define dotPeriod (100)
#define dashPeriod (dotPeriod*3)
#define relaxTime (dotPeriod)
#define letterSpace (dotPeriod*2)
#define wordSpace (dotPeriod*4)
#define buzz (300)

#define tonePin 0
#define ledPin 1

void di();
void dah();
void playLetter(char);


int main (void){

int pin;

   if (wiringPiSetup () == -1)
     exit (1) ;

  for (pin = 0 ; pin < 8 ; ++pin)
    pinMode (pin, OUTPUT) ;


  for(;;){ 
   playLetter('P');
   playLetter('D');
   playLetter('1');
   playLetter('C');
   playLetter('F');

   delay(3000);
  }
   return(0);
}

void di()
{
  //tone(tonePin, buzz);
  digitalWrite(ledPin, HIGH);
  digitalWrite(tonePin, HIGH);
  delay(dotPeriod);
  //noTone(tonePin);
  digitalWrite(ledPin, LOW);
  digitalWrite(tonePin, LOW);
  delay(relaxTime);
}

void dah()
{
  //tone(tonePin, buzz);
  digitalWrite(ledPin, HIGH);
  digitalWrite(tonePin, HIGH);
  delay(dashPeriod);
  //noTone(tonePin);
  digitalWrite(ledPin, LOW);
  digitalWrite(tonePin, LOW);
  delay(relaxTime);
}

void playLetter(char x)
{
	switch (x){
		case 'E':
			di(); break;
		case 'T':
			dah(); break;
		case 'A':
			di();dah(); break;
		case 'O':
			dah();dah();dah(); break;
                case 'P':
			di();dah();dah();di(); break;
                case 'D':
			dah();di();di(); break;
		case '1':
			di();dah();dah();dah();dah(); break;
		case 'C':
			dah();di();dah();di(); break;
                case 'F':
			di();di();dah();di(); break;
		case ' ':
			delay(wordSpace);
        }
}  
 
